(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('@angular/router'), require('rxjs/operators'), require('rxjs/internal/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng7-bootstrap-breadcrumb', ['exports', '@angular/core', 'rxjs', '@angular/router', 'rxjs/operators', 'rxjs/internal/operators', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ng7-bootstrap-breadcrumb'] = {}, global.ng.core, global.rxjs, global.ng.router, global.rxjs.operators, global.rxjs['internal/operators'], global.ng.common));
}(this, (function (exports, i0, rxjs, router, operators, operators$1, common) { 'use strict';

    var Ng7BootstrapBreadcrumbService = /** @class */ (function () {
        function Ng7BootstrapBreadcrumbService() {
            this.breadcrumbLabels = new rxjs.BehaviorSubject([]);
            this.newBreadcrumb = new rxjs.BehaviorSubject([]);
        }
        Ng7BootstrapBreadcrumbService.prototype.updateBreadcrumbLabels = function (labels) {
            this.breadcrumbLabels.next(labels);
        };
        Ng7BootstrapBreadcrumbService.prototype.updateBreadcrumb = function (newBreadcrumb) {
            this.newBreadcrumb.next(newBreadcrumb);
        };
        return Ng7BootstrapBreadcrumbService;
    }());
    Ng7BootstrapBreadcrumbService.ɵprov = i0.ɵɵdefineInjectable({ factory: function Ng7BootstrapBreadcrumbService_Factory() { return new Ng7BootstrapBreadcrumbService(); }, token: Ng7BootstrapBreadcrumbService, providedIn: "root" });
    Ng7BootstrapBreadcrumbService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    Ng7BootstrapBreadcrumbService.ctorParameters = function () { return []; };

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var Ng7BootstrapBreadcrumbComponent = /** @class */ (function () {
        function Ng7BootstrapBreadcrumbComponent(activatedRoute, router, ng7BootstrapBreadcrumbService) {
            this.activatedRoute = activatedRoute;
            this.router = router;
            this.ng7BootstrapBreadcrumbService = ng7BootstrapBreadcrumbService;
            this.breadcrumb = [];
            this.bgColor = '#eee';
            this.fontSize = '18px';
            this.fontColor = '#0275d8';
            this.lastLinkColor = '#000';
            this.symbol = ' / ';
            this.breadCrumbData();
        }
        Ng7BootstrapBreadcrumbComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.ng7BootstrapBreadcrumbService.breadcrumbLabels.subscribe(function (labelData) {
                var _loop_1 = function (label) {
                    if (labelData.hasOwnProperty(label)) {
                        _this.breadcrumb.map(function (crumb) {
                            var e_1, _a;
                            var labelParams = crumb.label.match(/[^{{]+(?=\}})/g);
                            if (labelParams) {
                                try {
                                    for (var labelParams_1 = (e_1 = void 0, __values(labelParams)), labelParams_1_1 = labelParams_1.next(); !labelParams_1_1.done; labelParams_1_1 = labelParams_1.next()) {
                                        var labelParam = labelParams_1_1.value;
                                        var dynamicData = labelData[label];
                                        if (labelParam === label) {
                                            crumb.label = crumb.label.replace('{{' + labelParam + '}}', dynamicData);
                                        }
                                    }
                                }
                                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                                finally {
                                    try {
                                        if (labelParams_1_1 && !labelParams_1_1.done && (_a = labelParams_1.return)) _a.call(labelParams_1);
                                    }
                                    finally { if (e_1) throw e_1.error; }
                                }
                            }
                        });
                    }
                };
                for (var label in labelData) {
                    _loop_1(label);
                }
            });
            this.ng7BootstrapBreadcrumbService.newBreadcrumb.subscribe(function (breadcrumb) {
                if (breadcrumb.length > 0) {
                    _this.updateData(_this.activatedRoute, breadcrumb);
                }
            });
        };
        Ng7BootstrapBreadcrumbComponent.prototype.breadCrumbData = function () {
            var _this = this;
            this.router.events
                .pipe(operators.filter(function (event) { return event instanceof router.NavigationEnd; }))
                .pipe(operators$1.map(function () { return _this.activatedRoute; }))
                .pipe(operators$1.map(function (route) {
                while (route.firstChild) {
                    route = route.firstChild;
                }
                return route;
            }))
                .pipe(operators.filter(function (route) { return route.outlet === router.PRIMARY_OUTLET; }))
                .subscribe(function (route) {
                _this.params = route.snapshot.params;
                _this.updateData(route, null);
            });
        };
        Ng7BootstrapBreadcrumbComponent.prototype.updateData = function (route, newBreadcrumb) {
            var _this = this;
            if (route.snapshot.data.breadcrumb || newBreadcrumb) {
                var data = route.snapshot.data.breadcrumb ? route.snapshot.data.breadcrumb : newBreadcrumb;
                var breadcrumb = (JSON.parse(JSON.stringify(data)));
                breadcrumb.map(function (crumb) {
                    var e_2, _a, e_3, _b;
                    var urlChunks = crumb.url.split('/');
                    try {
                        for (var urlChunks_1 = __values(urlChunks), urlChunks_1_1 = urlChunks_1.next(); !urlChunks_1_1.done; urlChunks_1_1 = urlChunks_1.next()) {
                            var chunk = urlChunks_1_1.value;
                            if (chunk.includes(':')) {
                                var paramID = chunk.replace(':', '');
                                // const routerParamID = route.snapshot.params[paramID];
                                var routerParamID = _this.params[paramID];
                                crumb.url = crumb.url.replace(":" + paramID, routerParamID);
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (urlChunks_1_1 && !urlChunks_1_1.done && (_a = urlChunks_1.return)) _a.call(urlChunks_1);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                    var labelParams = crumb.label.match(/[^{{]+(?=\}})/g);
                    if (labelParams) {
                        try {
                            for (var labelParams_2 = __values(labelParams), labelParams_2_1 = labelParams_2.next(); !labelParams_2_1.done; labelParams_2_1 = labelParams_2.next()) {
                                var labelParam = labelParams_2_1.value;
                                // const routerParamID = route.snapshot.params[labelParam.trim()];
                                var routerParamID = _this.params[labelParam.trim()];
                                if (routerParamID) {
                                    crumb.label = crumb.label.replace('{{' + labelParam + '}}', routerParamID);
                                }
                                else {
                                    // crumb.label = crumb.label.replace('{{' + labelParam + '}}', '');
                                }
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (labelParams_2_1 && !labelParams_2_1.done && (_b = labelParams_2.return)) _b.call(labelParams_2);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                    }
                });
                this.breadcrumb = breadcrumb;
            }
            else {
                this.breadcrumb = [];
            }
        };
        return Ng7BootstrapBreadcrumbComponent;
    }());
    Ng7BootstrapBreadcrumbComponent.decorators = [
        { type: i0.Component, args: [{
                    // tslint:disable-next-line: component-selector
                    selector: 'app-ng7-bootstrap-breadcrumb',
                    template: "<nav aria-label=\"breadcrumb\" [ngStyle]=\"{'background-color': bgColor}\">\r\n    <ol class=\"breadcrumb\" *ngIf=\"breadcrumb.length\">\r\n        <ng-container *ngFor=\"let item of breadcrumb; let i = index\">\r\n            <li class=\"breadcrumb-item\" [ngClass]=\"{'active': breadcrumb.length !== i+1}\" [ngStyle]=\"{'font-size': fontSize}\">\r\n                <a *ngIf=\"item?.url\" [routerLink]=\"item?.url\"  [ngStyle]=\"{'color': fontColor}\">{{ item.label }}</a>\r\n                <span *ngIf=\"!item?.url\" [ngStyle]=\"{'color': lastLinkColor}\">{{ item.label }}</span>\r\n            </li>\r\n        </ng-container>\r\n    </ol>\r\n</nav>\r\n",
                    styles: [""]
                },] }
    ];
    Ng7BootstrapBreadcrumbComponent.ctorParameters = function () { return [
        { type: router.ActivatedRoute },
        { type: router.Router },
        { type: Ng7BootstrapBreadcrumbService }
    ]; };
    Ng7BootstrapBreadcrumbComponent.propDecorators = {
        bgColor: [{ type: i0.Input }],
        fontSize: [{ type: i0.Input }],
        fontColor: [{ type: i0.Input }],
        lastLinkColor: [{ type: i0.Input }],
        symbol: [{ type: i0.Input }]
    };

    var Ng7BootstrapBreadcrumbModule = /** @class */ (function () {
        function Ng7BootstrapBreadcrumbModule() {
        }
        return Ng7BootstrapBreadcrumbModule;
    }());
    Ng7BootstrapBreadcrumbModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [Ng7BootstrapBreadcrumbComponent],
                    imports: [
                        router.RouterModule,
                        common.CommonModule
                    ],
                    exports: [Ng7BootstrapBreadcrumbComponent]
                },] }
    ];

    /*
     * Public API Surface of ng7-bootstrap-breadcrumb
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.Ng7BootstrapBreadcrumbComponent = Ng7BootstrapBreadcrumbComponent;
    exports.Ng7BootstrapBreadcrumbModule = Ng7BootstrapBreadcrumbModule;
    exports.Ng7BootstrapBreadcrumbService = Ng7BootstrapBreadcrumbService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng7-bootstrap-breadcrumb.umd.js.map
