import { OnInit } from '@angular/core';
import { ActivatedRoute, Router } from '@angular/router';
import { Breadcrumb } from './breadcrumb.model';
import { Ng7BootstrapBreadcrumbService } from './ng7-bootstrap-breadcrumb.service';
export declare class Ng7BootstrapBreadcrumbComponent implements OnInit {
    private activatedRoute;
    private router;
    private ng7BootstrapBreadcrumbService;
    breadcrumb: Breadcrumb[];
    bgColor: string;
    fontSize: string;
    fontColor: string;
    lastLinkColor: string;
    symbol: string;
    params: {
        [key: string]: any;
    };
    constructor(activatedRoute: ActivatedRoute, router: Router, ng7BootstrapBreadcrumbService: Ng7BootstrapBreadcrumbService);
    ngOnInit(): void;
    breadCrumbData(): void;
    private updateData;
}
